package com.perforce.maven.scm.provider.p4.cli;

import java.io.File;

import org.codehaus.plexus.interpolation.os.Os;
import org.codehaus.plexus.util.cli.CommandLineException;
import org.codehaus.plexus.util.cli.Commandline;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;

import com.perforce.maven.scm.provider.p4.AbstractPlexusTestCase;
import com.perforce.maven.scm.provider.p4.P4ScmTestUtils;

public class MvnCommandTest
    extends AbstractPlexusTestCase
{
    @Test
    @Ignore //this only works if this provider installed on local repo.  Need to move it to IT
    public void testClientDiscovery()
        throws CommandLineException
    {

        //test against this project SCM Url

        Commandline cl = new Commandline();
        cl.setExecutable( this.getMvn() );
        cl.setWorkingDirectory( new File( getBasedir() ) );
        cl.createArg().setLine( "scm:status" );

        StringBufferStreamConsumer stdout = new StringBufferStreamConsumer();
        StringBufferStreamConsumer stderr = new StringBufferStreamConsumer();

        P4ScmTestUtils.executeCommandLine( cl, stdout, stderr );

        Assert.assertFalse( "Current client is not discoverable.", stdout.getOutput().toString().contains( "client -d" ) );
        Assert.assertFalse( "Current client is not discoverable.", stdout.getOutput().toString().contains( "-MavenSCM-" ) );

        cl.setWorkingDirectory( new File( getBasedir() ).getParentFile() );

        stdout = new StringBufferStreamConsumer();
        stderr = new StringBufferStreamConsumer();

        P4ScmTestUtils.executeCommandLine( cl, stdout, stderr );

        Assert.assertFalse( "Current client is not discoverable.", stdout.getOutput().toString().contains( "client -d" ) );
        Assert.assertFalse( "Current client is not discoverable.", stdout.getOutput().toString().contains( "-MavenSCM-" ) );

    }

    private String getMvn()
    {
        String mvn = "mvn";

        if ( Os.isFamily( "windows" ) )
        {
            mvn += ".bat";
        }

        return mvn;
    }
}
